#include <stdio.h>
#include <iostream>
using namespace std;

#include <algorithm>
#include <iterator>
#include <vector>
#include <set>

const long long Pairbase = 1e9;

int n, k, T;
vector<int> A;
set<int> num;
set<long long> num_pair; // for a number pair (x, y), we store |y-x| * Pairbase + x


long long pack_pair(int x, int y)
{
    if(x < y) return Pairbase * (y - x) + x;
    else return Pairbase * (x - y) + y;
}

int extract_x(long long num)
{
    // extract x from num, x < y
    return int(num % Pairbase);
}

int main()
{
    scanf("%d%d", &n, &k);
    A.resize(n);
    for(int i=0; i<n; i++)
        scanf("%d", &A[i]);
    sort(A.begin(), A.end());
    /*
    for(int i=0; i<n; i++)
        cout << A[i] << ' ';
    cout << endl;
    */

    // init num: {-1, A[0], ..., A[n-1], k}
    num.insert(-1);
    for(int i=0; i<n; i++)
        num.insert(A[i]);
    num.insert(k);
    /*
    for(auto it=num.begin(); it!=num.end(); it++)
        cout << *it << ' ';
    cout << endl;
    */

    // init num_pair
    for(int i=1; i<n; i++)
        num_pair.insert(pack_pair(A[i-1], A[i]));
    /*
    for(auto it=num_pair.begin(); it!=num_pair.end(); it++)
        cout << *it << ' ';
    cout << endl;
    */

    T = 0;
    while(!num_pair.empty())
    {
        T++;
        int a, x, y, b;
        x = extract_x(*num_pair.begin());

        set<int>::iterator it, ita, itb;
        it = ita = itb = num.find(x);
        a = *(--ita);
        y = *(++itb);
        b = *(++itb);
        // ita => a, it => x, itb => b

        num.erase(it, itb); // delete x and y
        num_pair.erase(num_pair.begin()); // delete pair(x, y)
        if(a>=0) num_pair.erase(pack_pair(a, x)); // delete pair(a, x)
        if(b<k) num_pair.erase(pack_pair(y, b)); // delete pair(y, b)
        if(a>=0 && b<k) num_pair.insert(pack_pair(a, b)); // add pair(a, b)

        int z = (x + y) % k;
        //cout << T << ' ' << a << ' ' << x << ' ' << y << ' ' << b << ' ' << z << endl;
        it = num.lower_bound(z);
        if((*it)==z) continue; // z has already been in num

        b = *it;
        a = *(--it);
        if(a>=0 && b<k) num_pair.erase(pack_pair(a, b)); //delete pair(a, b)
        if(a>=0) num_pair.insert(pack_pair(a, z)); // add pair(a, z)
        if(b<k) num_pair.insert(pack_pair(z, b)); // add pair(z, b)
        num.insert(z); // add z
    }
    printf("%d\n", T);
    printf("%d\n", *(++num.begin()));
    return 0;
}
